library(targets)

# "nhdplusTools", "readxl", 
# "hyrefactor", "tidyr", "foreign", "hyfabric"

tar_option_set(packages = c("dplyr", "sf", "foreign", "hydroloom"),
               memory = "transient", garbage_collection = TRUE)

source("R/2_prep.R")
source("R/utils.R")
source("R/user_vars.R")
source("R/gage_mod.R")

# source("R/NHD_navigate.R")
# source("R/config.R")
# 
# 

list(

  tar_target(data_paths_file, "cache/data_paths.json", format = "file"),
  tar_target(data_paths, jsonlite::read_json(data_paths_file)),
  
  tar_target(usgs_ref_gages_file, data_paths$usgs_nldi_gages, format = "file"),
  tar_target(gages_ii_gages_file, data_paths$gagesii_lyr, format = "file"),
  tar_target(usgs_ref_gages, read_sf(usgs_ref_gages_file)),
  tar_target(gages_ii_ref, filter(usgs_ref_gages,
                                  id %in% filter(read_sf(gages_ii_gages_file), 
                                                 CLASS == "Ref")$STAID)),
  
  tar_target(SWIM_dbf_file, data_paths$SWIM_dbf, format = "file"),
  tar_target(SWIM_points_file, data_paths$SWIM_points_path, format = "file"),
  tar_target(SWIM, prepare_SWIM(SWIM_dbf_file, SWIM_points_file, usgs_ref_gages,
                                gages_add, POR_Start, min_da_km_gages, min_obs)),
  
  tar_target(NHDPlusV2_gageloc_file, data_paths$gageloc_info, format = "file"),
  tar_target(NHDPlusV2_gdb, data_paths$nhdplus_gdb),
  tar_target(NHDPlusV2_gages, prepare_gage_location(NHDPlusV2_gageloc_file, 
                                                    NHDPlusV2_gdb,
                                                    SWIM,
                                                    usgs_ref_gages,
                                                    min_da_km_gages))
  
  
)